Torque2D Reference

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Types | Public Member Functions | Static Public Attributes | Friends | List of all members
Value Class Reference

Represents a JSON value. More...

`#include <value.h>`

## Public Types
typedef std::vector< std::string > | Members
typedef ValueIterator | iterator
typedef ValueConstIterator | const_iterator
typedef Json::UInt | UInt
typedef Json::Int | Int
typedef UInt | ArrayIndex
typedef std::map< CZString, Value > | ObjectValues

## Public Member Functions
| Value (ValueType type=nullValue)
| Create a default Value of the given type. More...
| Value (Int value)
| Value (UInt value)
| Value (double value)
| Value (const char *value)
| Value (const char *beginValue, const char *endValue)
| Value (const StaticString &value)
| Constructs a value from a static string. More...
| Value (const std::string &value)
| Value (bool value)
| Value (const Value &other)
| ~Value ()
Value & | operator= (const Value &other)
void | swap (Value &other)
ValueType | type () const
bool | operator< (const Value &other) const
bool | operator<= (const Value &other) const
bool | operator>= (const Value &other) const
bool | operator> (const Value &other) const
bool | operator== (const Value &other) const
bool | operator!= (const Value &other) const
int | compare (const Value &other)
const char * | asCString () const
std::string | asString () const
Int | asInt () const
UInt | asUInt () const
double | asDouble () const
bool | asBool () const
bool | isNull () const
bool | isBool () const
bool | isInt () const
bool | isUInt () const
bool | isIntegral () const
bool | isDouble () const
bool | isNumeric () const
bool | isString () const
bool | isArray () const
bool | isObject () const
bool | isConvertibleTo (ValueType other) const
UInt | size () const
| Number of values in array or object. More...
bool | empty () const
| Return true if empty array, empty object, or null; otherwise, false. More...
bool | operator! () const
| Return isNull() More...
void | clear ()
void | resize (UInt size)
Value & | operator[] (UInt index)
const Value & | operator[] (UInt index) const
Value | get (UInt index, const Value &defaultValue) const
bool | isValidIndex (UInt index) const
| Return true if index < size(). More...
Value & | append (const Value &value)
| Append value to array at the end. More...
Value & | operator[] (const char *key)
| Access an object value by name, create a null member if it does not exist. More...
const Value & | operator[] (const char *key) const
| Access an object value by name, returns null if there is no member with that name. More...
Value & | operator[] (const std::string &key)
| Access an object value by name, create a null member if it does not exist. More...
const Value & | operator[] (const std::string &key) const
| Access an object value by name, returns null if there is no member with that name. More...
Value & | operator[] (const StaticString &key)
| Access an object value by name, create a null member if it does not exist. More...
Value | get (const char *key, const Value &defaultValue) const
| Return the member named key if it exist, defaultValue otherwise. More...
Value | get (const std::string &key, const Value &defaultValue) const
| Return the member named key if it exist, defaultValue otherwise. More...
Value | removeMember (const char *key)
| Remove and return the named member. More...
Value | removeMember (const std::string &key)
| Same as removeMember(const char*) More...
bool | isMember (const char *key) const
| Return true if the object has a member named key. More...
bool | isMember (const std::string &key) const
| Return true if the object has a member named key. More...
Members | getMemberNames () const
| Return a list of the member names. More...
void | setComment (const char *comment, CommentPlacement placement)
| Comments must be //... or /* ... */. More...
void | setComment (const std::string &comment, CommentPlacement placement)
| Comments must be //... or /* ... */. More...
bool | hasComment (CommentPlacement placement) const
std::string | getComment (CommentPlacement placement) const
| Include delimiters and embedded newlines. More...
std::string | toStyledString () const
const_iterator | begin () const
const_iterator | end () const
iterator | begin ()
iterator | end ()

## Static Public Attributes
static const Value | null
static const Int | minInt = Int( ~(UInt(-1)/2) )
static const Int | maxInt = Int( UInt(-1)/2 )
static const UInt | maxUInt = UInt(-1)

## Friends
class | ValueIteratorBase

## Detailed Description

Represents a JSON value.

This class is a discriminated union wrapper that can represents a:

- signed integer [range: Value::minInt - Value::maxInt]
- unsigned integer (range: 0 - Value::maxUInt)
- double
- UTF-8 string
- boolean
- 'null'
- an ordered list of Value
- collection of name/value pairs (javascript object)

The type of the held value is represented by a ValueType and can be obtained using type().

values of an objectValue or arrayValue can be accessed using operator[]() methods. Non const methods will automatically create the a nullValue element if it does not exist. The sequence of an arrayValue will be automatically resize and initialized with nullValue. resize() can be used to enlarge or truncate an arrayValue.

The get() methods can be used to obtanis default value in the case the required element does not exist.

It is possible to iterate over the list of a objectValue values using the getMemberNames() method.

## Member Typedef Documentation

typedef UInt ArrayIndex

typedef ValueConstIterator const_iterator

typedef Json::Int Int

typedef ValueIterator iterator

typedef std::vector<std::string> Members

typedef std::map<CZString, Value> ObjectValues

typedef Json::UInt UInt

## Constructor & Destructor Documentation

Value | ( | ValueType | type = `nullValue` | ) |

Create a default Value of the given type.

This is a very useful constructor. To create an empty array, pass arrayValue. To create an empty object, pass objectValue. Another Value can then be set to this one by assignment. This is useful since clear() and resize() will not alter types.

    Examples:

Json::Value null_value; // null
Json::Value arr_value(Json::arrayValue); // []
Json::Value obj_value(Json::objectValue); // {}

Value | ( | Int | value | ) |

Value | ( | UInt | value | ) |

Value | ( | double | value | ) |

Value | ( | const char * | value | ) |

Value | ( | const char * | beginValue,
|  | const char * | endValue
| ) |  |

Value | ( | const StaticString & | value | ) |

Constructs a value from a static string.

Like other value string constructor but do not duplicate the string for internal storage. The given string must remain alive after the call to this constructor. Example of usage:

Json::Value aValue( StaticString("some text") );

Value | ( | const std::string & | value | ) |

Value | ( | bool | value | ) |

Value | ( | const Value & | other | ) |

~Value | ( |  | ) |

## Member Function Documentation

Value & append | ( | const Value & | value | ) |

Append value to array at the end.

Equivalent to jsonvalue[jsonvalue.size()] = value;

bool asBool | ( |  | ) | const

const char * asCString | ( |  | ) | const

double asDouble | ( |  | ) | const

Value::Int asInt | ( |  | ) | const

std::string asString | ( |  | ) | const

Value::UInt asUInt | ( |  | ) | const

Value::const_iterator begin | ( |  | ) | const

Value::iterator begin | ( |  | ) |

void clear | ( | void |  | ) |

Remove all object members and array elements.

Precondition
  type() is arrayValue, objectValue, or nullValue

Postcondition
  type() is unchanged

int compare | ( | const Value & | other | ) |

bool empty | ( |  | ) | const

Return true if empty array, empty object, or null; otherwise, false.

Value::const_iterator end | ( | void |  | ) | const

Value::iterator end | ( | void |  | ) |

Value get | ( | UInt | index,
|  | const Value & | defaultValue
| ) |  | const

If the array contains at least index+1 elements, returns the element value, otherwise returns defaultValue.

Value get | ( | const char * | key,
|  | const Value & | defaultValue
| ) |  | const

Return the member named key if it exist, defaultValue otherwise.

Value get | ( | const std::string & | key,
|  | const Value & | defaultValue
| ) |  | const

Return the member named key if it exist, defaultValue otherwise.

std::string getComment | ( | CommentPlacement | placement | ) | const

Include delimiters and embedded newlines.

Value::Members getMemberNames | ( |  | ) | const

Return a list of the member names.

If null, return an empty list.

Precondition
  type() is objectValue or nullValue

Postcondition
  if type() was nullValue, it remains nullValue

bool hasComment | ( | CommentPlacement | placement | ) | const

bool isArray | ( |  | ) | const

bool isBool | ( |  | ) | const

bool isConvertibleTo | ( | ValueType | other | ) | const

bool isDouble | ( |  | ) | const

bool isInt | ( |  | ) | const

bool isIntegral | ( |  | ) | const

bool isMember | ( | const char * | key | ) | const

Return true if the object has a member named key.

bool isMember | ( | const std::string & | key | ) | const

Return true if the object has a member named key.

bool isNull | ( | void |  | ) | const

bool isNumeric | ( |  | ) | const

bool isObject | ( |  | ) | const

bool isString | ( |  | ) | const

bool isUInt | ( |  | ) | const

bool isValidIndex | ( | UInt | index | ) | const

Return true if index < size().

bool operator! | ( |  | ) | const

Return isNull()

bool operator!= | ( | const Value & | other | ) | const

bool operator< | ( | const Value & | other | ) | const

bool operator<= | ( | const Value & | other | ) | const

Value & operator= | ( | const Value & | other | ) |

bool operator== | ( | const Value & | other | ) | const

bool operator> | ( | const Value & | other | ) | const

bool operator>= | ( | const Value & | other | ) | const

Value & operator[] | ( | UInt | index | ) |

Access an array element (zero based index ). If the array contains less than index element, then null value are inserted in the array so that its size is index+1. (You may need to say 'value[0u]' to get your compiler to distinguish this from the operator[] which takes a string.)

const Value & operator[] | ( | UInt | index | ) | const

Access an array element (zero based index ) (You may need to say 'value[0u]' to get your compiler to distinguish this from the operator[] which takes a string.)

Value & operator[] | ( | const char * | key | ) |

Access an object value by name, create a null member if it does not exist.

const Value & operator[] | ( | const char * | key | ) | const

Access an object value by name, returns null if there is no member with that name.

Value & operator[] | ( | const std::string & | key | ) |

Access an object value by name, create a null member if it does not exist.

const Value & operator[] | ( | const std::string & | key | ) | const

Access an object value by name, returns null if there is no member with that name.

Value & operator[] | ( | const StaticString & | key | ) |

Access an object value by name, create a null member if it does not exist.

If the object as no entry for that name, then the member name used to store the new entry is not duplicated. Example of use:

Json::Value object;
static const StaticString code("code");
object[code] = 1234;

Value removeMember | ( | const char * | key | ) |

Remove and return the named member.

Do nothing if it did not exist.

Returns
  the removed Value, or null.

Precondition
  type() is objectValue or nullValue

Postcondition
  type() is unchanged

Value removeMember | ( | const std::string & | key | ) |

Same as removeMember(const char*)

void resize | ( | UInt | size | ) |

Resize the array to size elements. New elements are initialized to null. May only be called on nullValue or arrayValue.

Precondition
  type() is arrayValue or nullValue

Postcondition
  type() is arrayValue

void setComment | ( | const char * | comment,
|  | CommentPlacement | placement
| ) |  |

Comments must be //... or /* ... */.

void setComment | ( | const std::string & | comment,
|  | CommentPlacement | placement
| ) |  |

Comments must be //... or /* ... */.

Value::UInt size | ( | void |  | ) | const

Number of values in array or object.

void swap | ( | Value & | other | ) |

Swap values.

Note
  Currently, comments are intentionally not swapped, for both logic and efficiency.

std::string toStyledString | ( |  | ) | const

ValueType type | ( |  | ) | const

## Friends And Related Function Documentation

friend class ValueIteratorBase
| friend

## Member Data Documentation

const Int maxInt = Int( UInt(-1)/2 )
| static

const UInt maxUInt = UInt(-1)
| static

const Int minInt = Int( ~(UInt(-1)/2) )
| static

const Value null
| static

The documentation for this class was generated from the following files:

- persistence/rapidjson/thirdparty/jsoncpp/include/json/value.h
- persistence/rapidjson/thirdparty/jsoncpp/src/lib_json/json_value.cpp